﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Json;
using System.Reflection;
using System.Reflection.Emit;

namespace SilverlightApplication2
{
    public class MyTools
    {
        public static List<String> GetCoumsByJson(string Json)
        {
            List<String> str_list = new List<string>();

            try
            {

                JsonValue ja = JsonArray.Parse(Json);
                foreach (string item in (((JsonObject)(ja[0]))).Keys)
                {
                    if (!str_list.Contains(item))
                        str_list.Add(item.ToUpper());
                }
            }
            catch (Exception e)
            {
            
            }

            return str_list;
        }


        public static Type getTypeByStrList(List<String> str_list)
        {


         

            string className = "TempType" + Guid.NewGuid().ToString().Replace('-', 'a');
            try
            {
                #region 反射形成类型的初始工作
                AssemblyName an = new AssemblyName("TempAssembly" + Guid.NewGuid());
                AssemblyBuilder assemblyBuilder =
                    AppDomain.CurrentDomain.DefineDynamicAssembly(
                        an, AssemblyBuilderAccess.Run);
                ModuleBuilder moduleBuilder = assemblyBuilder.DefineDynamicModule("MainModule");
                TypeBuilder typeBuilder = moduleBuilder.DefineType(className
                                    , TypeAttributes.Public |
                                    TypeAttributes.Class |
                                    TypeAttributes.AutoClass |
                                    TypeAttributes.AnsiClass |
                                    TypeAttributes.BeforeFieldInit |
                                    TypeAttributes.AutoLayout
                                    , typeof(object));
                ConstructorBuilder constructor =
                        typeBuilder.DefineDefaultConstructor(
                                    MethodAttributes.Public |
                                    MethodAttributes.SpecialName |
                                    MethodAttributes.RTSpecialName);
                #endregion

                #region 给类型加字段


                foreach (string item in str_list)
                {
                    Type type = typeof(string);
                    FieldBuilder fieldABuilder = typeBuilder.DefineField(item, type, FieldAttributes.Private);
                    fieldABuilder.SetConstant("");
                    PropertyBuilder propertyABuilder = typeBuilder.DefineProperty(item, System.Reflection.PropertyAttributes.None, type, null);
                    MethodBuilder getPropertyABuilder = typeBuilder.DefineMethod("get",
                        MethodAttributes.Public | MethodAttributes.SpecialName | MethodAttributes.HideBySig,
                        type,
                        Type.EmptyTypes);

                    ILGenerator getAIL = getPropertyABuilder.GetILGenerator();
                    getAIL.Emit(OpCodes.Ldarg_0);
                    getAIL.Emit(OpCodes.Ldfld, fieldABuilder);
                    getAIL.Emit(OpCodes.Ret);
                    //定义属性A的set方法
                    MethodBuilder setPropertyABuilder = typeBuilder.DefineMethod("set",
                        MethodAttributes.Public | MethodAttributes.SpecialName | MethodAttributes.HideBySig,
                        null,
                        new Type[] { type });
                    //生成属性A的set方法的IL代码，即设置私有字段_a值为传入的参数1的值
                    ILGenerator setAIL = setPropertyABuilder.GetILGenerator();
                    setAIL.Emit(OpCodes.Ldarg_0);
                    setAIL.Emit(OpCodes.Ldarg_1);
                    setAIL.Emit(OpCodes.Stfld, fieldABuilder);
                    setAIL.Emit(OpCodes.Ret);
                    //设置属性A的get和set方法
                    propertyABuilder.SetGetMethod(getPropertyABuilder);
                    propertyABuilder.SetSetMethod(setPropertyABuilder);

                }
                #endregion


                return typeBuilder.CreateType();
            }
            catch (Exception e)
            {
                return null;
            }
        }

    }
}
